This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 175988 - hang-check timer needs to be build on S390/S390x
hang-check timer needs to be build on S390/S390x
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.0
s390 Linux
medium Severity medium
: ---
: ---
Assigned To: Jan Glauber
Brian Brock
:
Depends On:
Blocks: 168430
  Show dependency treegraph
 
Reported: 2005-12-16 17:35 EST by Linda Wang
Modified: 2007-11-30 17:07 EST (History)
1 user (show)

See Also:
Fixed In Version: RHSA-2006-0132
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-03-07 16:07:01 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
hangcheck-timer.diff (3.44 KB, patch)
2006-01-11 16:27 EST, Jan Glauber
no flags Details | Diff

  None (edit)
Description Linda Wang 2005-12-16 17:35:40 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.8) Gecko/20050512 Red Hat/1.0.4-1.4.1 Firefox/1.0.4

Description of problem:
hangcheck-timer kernel modules are currently not build on s390 and s390x
arches.

Version-Release number of selected component (if applicable):
kernel-2.6.9-25

How reproducible:
Always

Steps to Reproduce:
1.install RHEL4 U3 kernel on s390 machine
2.cd /lib/modules/2.6.9-25/
3.search for hangcheck-timer.ko
  

Additional info:
Comment 2 Jan Glauber 2005-12-20 11:18:47 EST
This is just a matter of including the Kconfig where HANGCHECK_TIMER
is configured. But this is drivers/char/Kconfig which we currently do not
include from s390 Kconfig since there is too much stuff there that don't makes
sense on s390.

I wonder why the hangcheck timer is not in the watchdog directory?
(The watchdog/Kconfig is included from s390 Kconfig).

Comment 4 Jan Glauber 2006-01-09 10:00:01 EST
The hangcheck timer also needs a monotonic_clock function.
This is currently not implemented on s390 but it could be easily
done by using get_clock().
Comment 5 Jan Glauber 2006-01-10 07:36:30 EST
Um, just figured out that Jason already added the monotonic_clock function,
so this patch is not upstream.

Jason: 
The comment from the archs that have the monotonic_clock() says:
/* monotonic_clock(): returns # of nanoseconds passed since time_init()

Your code just returns get_clock() which is nanoseconds since 1900.
But time_init should refer to the time the machine booted.
Therfore it should be get_clock() - jiffies_timer_cc, or?
Comment 6 Jason Baron 2006-01-10 17:33:28 EST
well, i agree it doesn't meet the spec, but the way its implemented should be
fine since we subtract out the previous value that monotonic_clock() returned.
thus, the starting point is irrelevant as long as its conssitent.
Comment 7 Jan Glauber 2006-01-11 16:26:37 EST
Correct, it should work if it only takes the difference.
But I think this could be easier done by adding the monotonic_clock
interface to s390 arch code. See my attached patch.

BTW, your definition of the s390 second had a typo ;-
Comment 8 Jan Glauber 2006-01-11 16:27:52 EST
Created attachment 123076 [details]
hangcheck-timer.diff
Comment 9 Jason Baron 2006-01-12 17:02:25 EST
look good to me...probably worth sending upstream as well.
Comment 10 Jan Glauber 2006-01-13 03:56:57 EST
I've talked with Martin Schwidefsky, he has no objections
to the monotonic_clock in our arch code, so we will send this
upstream too.
Comment 15 Red Hat Bugzilla 2006-03-07 16:07:02 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0132.html

Note You need to log in before you can comment on or make changes to this bug.